/*
Scrivere un programma per la gestione dei libri di una biblioteca. Ciascun libro e' caratterizzato dalle seguente informazioni: titolo, nome autore, collocazione,  genere.
Le informazioni sono inserite in un vettore di 5 liste, una per ogni genere. 
Le liste sono ordinate rispetto alla collocazione.
Le persone per potere chiedere in prestito un libro devono essere inserite in una coda. Al momento dell'inserimento vengono chieste e inserite le seguenti informazioni: nome della persona, titolo del libro e sua categoria.
Nel momento in cui una persona viene servita (out coda) viene verificato che il libro esiste e,  se presente, viene stampato il titolo del libro.
Nel programma  presente un men caratterizzato dalle seguenti funzioni:
1)	Inserimento di un nuovo libro nella lista relativa alla sua categoria;
2)	Visualizzazione dei libri di una certa categoria;
3)	Inserimento in coda;
4)	Eliminazione dalla coda dopo avere verificato la presenza del libro;
5)	Visualizzazione della coda.

Liberare la memoria allocata dinamicamente.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
        char titolo[80];
        char autore[50];
        int collocazione,genere;
        }libro;
        
struct atomo {
       libro dato;
       struct atomo *next;
       };
       
typedef struct {
        char nome[80]; 
        char titolo[80];
        int genere;
        } prestito;

struct atomocoda {
       prestito dato;
       struct atomocoda *suc;
       };
       
typedef struct {
         struct atomocoda *primo,*ultimo;
         } coda; 
         
void ins_ord(struct atomo *VL[5]);
void visualizza_lista(struct atomo *tl);
void in_coda(coda *Q);
void ricerca(struct atomo *tl, char *titolo);
void out_coda(coda *Q);
void visualizza_coda(coda Q);

main() {
       struct atomo *L[5],*al;
       coda Q;
       int i;
       int opz;
       struct atomocoda *ac;
       prestito p;
       
       
       /* inizializzazione */
         for(i=0;i<5;i++)
          L[i]=NULL;
          
         Q.primo=NULL;
         Q.ultimo=NULL;
         
         do {
             printf("Scegli\n");
             printf("1. Ins. libro\n2. Visualizza libri\n");
             printf("3. Ins. in coda\n4. Servi coda\n");
             printf("5. Visualizza coda\n0. Fine\n");
             scanf("%d",&opz);
             switch(opz) {
               case 1:  /* ins. libro */
                         ins_ord(L);
                         break;
               case 2:   /* visualizzazione per genere*/
                         printf("Genere (0..4): ");
                         scanf("%d",&i);
                         visualizza_lista(L[i]);
                         break;
               case 3:   /* ins. in coda */
                         in_coda(&Q);
                         break;
               case 4:  /* servizio coda: ricerca + outcoda */
                         if(Q.primo!=NULL)
                          { p=Q.primo->dato;
                            ricerca(L[p.genere],p.titolo);
                            out_coda(&Q);
                          }
                         break;
               case 5:   visualizza_coda(Q);
                         break;
               default:; }
               } while(opz!=0);
             
             /* liberiamo la memoria */
             
             while(Q.primo!=NULL)
             /* fino a quando la coda non e' vuota */
               { ac=Q.primo;
                 Q.primo=ac->suc;
                 free(ac);
               }
               
             for(i=0;i<5;i++)
              while(L[i]!=NULL)
               /* fino a quando la lista L[i] non e' vuota*/
                 {al=L[i];
                  L[i]=al->next;
                  free(al);
                 }
}

void ins_ord(struct atomo *VL[5])
{
     libro l;
     struct atomo *aux,*ll;
     int i;
     
     /* lettura libro*/
     printf("Titolo: ");
     fflush(stdin);
     gets(l.titolo);
     printf("Autore: ");
     gets(l.autore);
     printf("Collocazione: ");
     scanf("%d",&l.collocazione);
     printf("Genere (0..4): ");
     scanf("%d",&l.genere);
     
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL) return;
     aux->dato=l;
     i=l.genere;
     if(VL[i]==NULL || l.collocazione < VL[i]->dato.collocazione)
     { /* inserimento in testa */
        aux->next=VL[i];
        VL[i]=aux;
        return;
        }
        
     ll=VL[i];
     while(ll->next!=NULL)
      if(l.collocazione < ll->next->dato.collocazione)
         break;
      else ll=ll->next;
      aux->next=ll->next;
      ll->next=aux;
}

void visualizza_lista(struct atomo *tl)
{
     while(tl!=NULL)
      {  printf("Titolo: %s\n",tl->dato.titolo);
         printf("Autore: %s\n",tl->dato.autore);
         printf("Collocazione: %d\n",tl->dato.collocazione);
         tl=tl->next;
      }
}
      
     
void in_coda(coda *Q)
{
  prestito p;
  struct atomocoda *ac;
  
  printf("Nome: ");
  fflush(stdin);
  gets(p.nome);
  printf("Titolo: ");
  gets(p.titolo);
  printf("Genere (0..4) ");
  scanf("%d",&p.genere);
  
  ac=(struct atomocoda *) malloc(sizeof(struct atomocoda));
  if(ac==NULL) return;
  ac->dato=p;
  ac->suc=NULL;
  if(Q->primo==NULL)
     Q->primo=ac;
  else Q->ultimo->suc=ac;
  Q->ultimo=ac;
   
}

void ricerca(struct atomo *tl, char *titolo)
{
     while(tl!=NULL)
      if(strcmp(tl->dato.titolo,titolo)==0)
        /* se ho trovato il libro */
        {  printf("Titolo: %s\n",titolo);
           return;
        }
      else tl=tl->next;
      
      /* se si e' arrivati in questo punto il libro non
         e' presente*/
      printf("Il libro non e' presente\n");
}          
         
void out_coda(coda *Q)
{
     struct atomocoda *ac;
     
     
     if(Q->primo==NULL)
        return;
     ac=Q->primo;
     
     Q->primo=ac->suc;
     free(ac);
     if(Q->primo==NULL)
       Q->ultimo=NULL;
}
     
        


void visualizza_coda(coda Q)
{ struct atomocoda *a;

  a=Q.primo;
  while(a!=NULL)
    { printf("Nome: %s\n",a->dato.nome); 
      printf("Titolo: %s\n",a->dato.titolo);
      a=a->suc;
    }
}
               
                         

         
         
              
