/*
Scrivere un programma per la gestione delle informazioni relative alle operazioni relative ad una banca.
La banca ha 3 sportelli, uno per ogni tipo di operazione. Ogni sportello ha una propria coda di clienti. 
I clienti sono caratterizzati dalle seguenti informazioni: nome, codice fiscale, tipo di operazione.
Nel momento in cui un cliente viene servito, vengono conservate in una tabella allocata dinamicamente le seguenti informazioni relative all'operazione appena eseguita: codice fiscale, importo dell'operazione, data dell'operazione, tipo operazione.
La tabella contiene 3 righe, una per tipo di operazione. 
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1)	Inserimento in coda di un nuovo cliente; 
2)	Visualizzazione dei clienti di una certa coda;
3)	Servizio del primo elemento della coda e inserimento dell'operazione appena eseguita nella tabella;
4)	Visualizzazione delle operazioni gi eseguite relative a una certa data;
5)	Salvataggio su file del contenuto del contenuto della tabella.

All'avvio del programma le operazioni precedentemente salvate su file devono essere lette e copiati nella tabella mediante una funzione di inizializzazione. 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
        char nome[60];
        char codfisc[17];
        int tipo;
        } cliente;

struct atomo {
       cliente dato;
       struct atomo *next;
       };
typedef struct {
        struct atomo *primo,*ultimo; 
        } coda;
        
typedef struct {
        char codfisc[17];
        char data[12];
        float importo;
        int tipo;
        } operazione;
        
void ins_coda(coda VQ[3]);
void vis_coda(coda Q);
void ins_operazione(operazione **R, int *n, operazione op); 
void out_coda(coda *Q, operazione **R, int *n);
void vis_tabella(operazione  *T[3], int N[3]);
void salva(operazione *T[3], int N[3]); 
void inizializza(operazione *T[3], int N[3]);

main() {
       operazione *TB[3];
       coda VQ[3];
       int N[3];
       int i, scelta;
       
       struct atomo *a;
       
       /* inizializzazione*/
       
       for(i=0;i<3;i++)
         { VQ[i].primo=NULL;
           VQ[i].ultimo=NULL;
           TB[i]=NULL;
           N[i]=0;
         }
        inizializza(TB,N); 
               
        do {
            printf("Seleziona una delle seguenti operazioni\n");
            printf("1- Ins. in coda\n2- Vis. coda\n3- Servi coda\n");
            printf("4- Vis. operazioni per data\n5- Salvataggio su file\n");
            printf("0- Fine\n");
            scanf("%d",&scelta);
            switch(scelta) {
            case 1:    ins_coda(VQ);
                       break;
            case 2:    printf("Quale coda ? (0..2) ");
                       scanf("%d",&i);
                       vis_coda(VQ[i]);
                       break;
            case 3:    printf("Quale coda ? (0..2) ");
                       scanf("%d",&i);
                       if(VQ[i].primo!=NULL)
                        /* se la coda di indice i non e' vuota*/
                          
                           out_coda(&VQ[i],&TB[i],&N[i]);
                       else printf("Coda vuota\n");
                       break;
            case 4:    vis_tabella(TB,N);
                       break;
            case 5:    salva(TB,N);
                       break;
            default:;  }
            } while(scelta!=0);
        
        /* liberazione della memoria */
         
         for(i=0;i<3;i++)
         {
            free(TB[i]);
            
            while(VQ[i].primo!=NULL)
              {
                a=VQ[i].primo;
                VQ[i].primo=a->next;
                free(a);
              }
         }
}        
        
void ins_coda(coda VQ[3])
{
  struct atomo *a;   
  cliente cl;
  int i;
  
  printf("Nome: ");
  fflush(stdin);
  gets(cl.nome);
  printf("Codice fiscale ");
  gets(cl.codfisc);
  printf("Tipo operazione (0..2) ");
  scanf("%d",&cl.tipo);
  i=cl.tipo;
   a=(struct atomo *) malloc(sizeof(struct atomo));
   if(a==NULL) return;
   a->dato=cl;
   a->next=NULL;
   if(VQ[i].primo==NULL)
      VQ[i].primo=a;
   else VQ[i].ultimo->next=a;
   VQ[i].ultimo=a;
}  
     
void vis_coda(coda Q)
{
     struct atomo *a;
     
     a=Q.primo;
     while(a!=NULL)
       {  printf("Cod. fiscale: %s\n",a->dato.codfisc);
          printf("Nome: %s\n",a->dato.nome);
          a=a->next;
       }
}
     
void ins_operazione(operazione **R, int *n, operazione op)
{
     operazione *a;
     
     a= (operazione *) realloc(*R, sizeof(operazione)*(*n+1));
     if(a==NULL) return;
     *R=a;
     (*R)[*n]=op;
     (*n)++;
}
     
void out_coda(coda *Q, operazione **R, int *n)
{
   struct atomo *a;
   cliente cl;
   operazione op;
   
   /* questa funzione viene invocata solo se la coda non e' vuota*/
     
    a=Q->primo; 
    
    /* riempiamo in campi dell'operazione da inserire nella tabella */
    op.tipo=a->dato.tipo;
    strcpy(op.codfisc,a->dato.codfisc);
    printf("Data operazione ");
    scanf("%s",op.data);
    printf("Importo ");
    scanf("%f",&op.importo);
    /* inseriamo l'operazione nella riga di indirizzo R (puntatore a puntatore) */
    ins_operazione(R,n,op);
    
    /* eliminiamo il primo elemento dalla coda*/
    Q->primo=a->next;
    free(a);
    if(Q->primo==NULL)
     Q->ultimo=NULL;
} 
     
void vis_tabella(operazione  *T[3], int N[3])
{
  int i,j;
  char data[12];
  
  printf("Data (gg/mm/aaaa) ");
  scanf("%s",data);
  for(i=0;i<3;i++)
   for(j=0;j<N[i];j++)
     if(strcmp(data,T[i][j].data)==0)
       {  printf("Cod. fiscale: %s\n",T[i][j].codfisc);
          printf("Importo: %f\n",T[i][j].importo);
          }
 }
 
 
void salva(operazione *T[3], int N[3])
{
     FILE *pf;
     int i,j;
     
     pf=fopen("operazioni.op","w");
     if(pf) {
              for(i=0;i<3;i++)
               for(j=0;j<N[i];j++)
                  fwrite(&T[i][j],sizeof(operazione),1,pf);
              /* oppure 
                for(i=0;i<3;i++)
                  fwrite(T[i],sizeof(operazione),N[i],pf);
                  */
              fclose(pf); 
            }
}            
         
                     
void inizializza(operazione *T[3], int N[3])
{
     FILE *pf; 
     operazione op;
     int i;
     
     pf=fopen("operazioni.op","r");
     if(pf) {
              while(fread(&op,sizeof(operazione),1,pf)!=0)
               {i=op.tipo;
                 ins_operazione(&T[i],&N[i],op);
               }
              fclose(pf);
           }       
}
       
       
       
       
       
       
       















